#!ruby -Ks
# -*- mode: ruby; encoding: sjis -*-
# Last updated: <2014/01/26 20:08:35 +0900>

require 'dxruby'
require_relative 'floorraster'

# _CBG
class BgCloud
  attr_accessor :image, :u, :v, :du, :dv, :alpha, :z, :f_dist, :blend
  attr_accessor :bg, :bg2

  #
  # 
  #
  # @param [Image] img `Ɏg摜
  # @param [float] du XN[x
  # @param [float] dv XN[x
  # @param [int] z `[xB}CiXlȂ牜BvXlȂO
  # @param [float] alpha At@lB0.0-1.0͈̔͂Ŏw
  # @param [float] f_dist ܂ł̋
  # @param [Object] @B:alpha  :add wł
  #
  def initialize(img, du, dv, z, alpha, f_dist=0.8, blend=:alpha)
    self.image = img
    self.bg = FloorRaster.new(self.image)
    self.bg2 = FloorRaster.new(self.image)
    c = [0.0, 0.0, 0.0, 1.0]
    self.bg.set_fog(4, c)
    self.bg2.set_fog(4, c)
    self.u = 0
    self.v = 0
    self.du = du
    self.dv = dv
    self.alpha = alpha
    self.z = z
    self.f_dist = f_dist
    self.blend = blend
  end

  # XV
  def update
    self.u += self.du
    self.v += self.dv
  end

  # `
  def draw
    self.bg.draw(320, 240, self.u, self.v, :floor_dist=>self.f_dist,
                 :y_dist=>0, :z=>self.z, :alpha=>self.alpha,
                 :blend=>self.blend)
    self.bg2.draw(320, 240, self.u, self.v, :floor_dist=>self.f_dist,
                  :y_dist=>0, :z=>self.z, :alpha=>self.alpha,
                  :blend=>self.blend, :vflip=>true)
  end

  # XN[xύX
  def add_spd(du, dv)
    self.du += du
    self.dv += dv
  end
end

if $0 == __FILE__
  # mF

  z = -20
  ras_bg = []
  ras_bg.push(BgCloud.new(Image.load("res/mecha_tile.png"),
                          4, 2, z - 2, 1.0, 1.5))
  ras_bg.push(BgCloud.new(Image.load("res/cloud4.png"),
                          4, 2, z - 1, 0.8, 0.5, :add))

  Window.loop do
    break if Input.keyPush?(K_ESCAPE)
    ras_bg.each { |bg| bg.update }
    ras_bg.each { |bg| bg.draw }
  end


end
