#!ruby -Ks
# -*- mode: ruby; encoding: sjis -*-
# Last updated: <2014/01/26 21:45:30 +0900>

require 'dxruby'
require_relative 'starrasterbg'
require_relative 'floorraster'
require_relative 'dxrbtmx'
require_relative 'bgatari'
require_relative 'bgcloud'

# BG\ǗNX
class BgDisp

  attr_accessor :stage_num
  attr_accessor :bg_x, :bg_y, :bg_z
  attr_accessor :bg_x_spd, :bg_y_spd
  attr_accessor :bgatari
  attr_accessor :bg_chg_x
  attr_accessor :enemy_tbl
  attr_accessor :ras_bgx_spd, :ras_bgz_spd
  attr_accessor :ras_bg

  @@data = [
    {:chip=>"res/bgchip.png", :tmx=>"res/stage1.tmx"}, # stage 1
    {:chip=>"res/bgchip.png", :tmx=>"res/stage1.tmx"}, # stage 2
    {:chip=>"res/bgchip.png", :tmx=>"res/stage1.tmx"}, # stage 3
  ]

  #
  # eXe[WBG
  #
  # @param [int] stage_num Xe[WԍB0Xe[W1
  # @param [float] sx BG\Jnʒux
  # @param [float] sy BG\Jnʒuy
  # @param [float] sx_spd BGXN[xx
  # @param [float] sy_spd BGXN[xy
  # @param [int] z BG\[xB}CiXlȂ牜ɁAvXlȂOɕ`悳
  #
  def initialize(stage_num, sx, sy, sx_spd, sy_spd, z)
    @stage_num = stage_num
    @bg_x = sx
    @bg_y = sy
    @bg_x_spd = sx_spd
    @bg_y_spd = sy_spd
    @bg_z = z

    sw, sh = Window.width, Window.height
    tw, th = 16, 16

    # BG^C摜ǂݍ
    @tileimgs = Image.loadTiles(@@data[stage_num][:chip], 256/tw, 512/th)

    # BG}bvt@C(.tmx)ǂݍ
    @tmx = DxrbTmx.new(@@data[stage_num][:tmx], sw, sh)

    # C[w肵āADXRuby̕`p}bvf[^(񎟌z)擾
    @atari_layer = @tmx.get_layer("atari")
    @bg_layer0 = @tmx.get_layer("layer0")

    # ʂ߂^C擾
    @bgtw = @tmx.screenwidth
    @bgth = @tmx.screenheight

    # BGA^pe[u쐬
    @bgatari = BgAtari.new(@tileimgs, @atari_layer, sw, sh, 0)

    @bg_chg_x = 0

    case stage_num
    when 0
      # Xe[W1
      @bg_chg_x = 2600

      # wiBG
      @star_shader = StarRasterScrollShader.new(0.25, 2.0)
      @star_bgimg = @star_shader.get_star_image( Window.width, Window.height,
                                                0x00fff)

      # _CBG
      @ras_bg = []
      @ras_bg.push(BgCloud.new(Image.load("res/mecha_tile.png"),
                               4, 2, z - 2, 1.0, 1.5))
      @ras_bg.push(BgCloud.new(Image.load("res/cloud4.png"),
                               4, 2, z - 1, 0.8, 0.5, :add))

      @alpha = 1.0
    end

    @step = 0
    @kind = 0

    @count = 1
  end

  # XV
  def update

    # BGWXV
    @bg_x += @bg_x_spd
    @bg_y += @bg_y_spd

    xmax = @tmx.map_width - Window.width - 1
    if @bg_x >= xmax
      @bg_x = xmax
      @bg_x_spd = 0
    end

    case @stage_num
    when 0
      # Xe[W1
      # wl𒴂BGނύX
      @kind = 1 if @bg_x >= @bg_chg_x

      case @kind
      when 0
        # 
        @star_shader.set_alpha(@alpha)
        @star_shader.update
      when 1
        # _C
        @ras_bg.each { |bg| bg.update }
      end
    end
  end

  # `揈
  def draw
    z = @bg_z
    # ʏwi`
    Window.drawTile(0, 0, @bg_layer0, @tileimgs,
                    @bg_x, @bg_y, @bgtw, @bgth, z)

    # A܂͉_C`
    z -= 10
    case @stage_num
    when 0
      # Xe[W1
      case @kind
      when 0
        # `
        Window.draw_shader(0, 0, @star_bgimg, @star_shader, z)
      when 1
        # _C`
        @ras_bg.each { |bg| bg.draw }
      end
    end
  end

  # Xe[W1p̉_CBGXN[xω
  def add_ras_bg_spd(x, z)
    @ras_bg[0].add_spd(x, z)
    @ras_bg[1].add_spd(x, z)
  end

  #
  # BGWԂ
  #
  # @return {Array] x,yWԂ
  def get_bg_pos
    return @bg_x, @bg_y
  end

  #
  # BG̃XN[~߂
  #
  def stop_bg_scroll
    @bg_x_spd = 0
  end

  #
  # wWBGR[hԂ
  #
  # @param [int] x wWx (ʓWB[hWł͂Ȃ)
  # @param [int] y wWy (ʓWB[hWł͂Ȃ)
  # @return [int] BGR[h
  #
  def get_bgcode(x, y)
    return @bgatari.get_bg_code(@bg_x + x, @bg_y + y)
  end

  #
  # wWn`ƓĂ邩ǂԂ
  #
  # @param [int] x wWx (ʓWB[hWł͂Ȃ)
  # @param [int] y wWy (ʓWB[hWł͂Ȃ)
  # @return [Boolean] ĂȂtrue
  # @return [nil] ĂȂȂ nil
  #
  def check_bg_hit(x, y)
    return @bgatari.check_bg_hit(@bg_x + x, @bg_y + y, BgAtari::ADJUST_NONE)
  end

  #
  # BGƂ̕␳WԂ
  #
  # @param [int] x wWx (ʓWB[hWł͂Ȃ)
  # @param [int] y wWy (ʓWB[hWł͂Ȃ)
  # @param [int] kind ␳BBgAtari::ADJUST_(UP|DOWN|LEFT|RIGHT)w\
  # @return [Array] ␳x,yWBGR[hԂBnil,nilȂ瓖ĂȂB
  #
  def get_hosei(x, y, kind)
    tx = @bg_x + x
    ty = @bg_y + y
    nx, ny = @bgatari.adjust_bg_hit(tx, ty, kind)
    return (nx - @bg_x), (ny - @bg_y), @bgatari.bg_code
  end

  #
  # Ge[u擾
  #
  # @param [int] start_x BGXN[̊JnxWB܂ł͓Ge[u珜O
  # @return [Array] Ge[uB[IuWFNg, x, y]̔z
  def get_enemy_table(start_x)
    tbls = @tmx.get_object_group_info
    a = []
    tbls.each do |l|
      next if l[:layername] != "enemy"
      l[:data].each do |d|
        name, x, y = d[:name], d[:x].to_i, d[:y].to_i
        next if start_x > x
        a.push({:name=>name, :x=>x, :y=>y})
      end
    end
    r = a.sort{|p,q| p[:x]<=>q[:x]}
    return r
  end
end
