#!ruby -Ks
# -*- mode: ruby; encoding: sjis -*-
# Last updated: <2014/01/19 01:30:50 +0900>

require 'dxruby'

# vC[S̔GtFNg
class DeadEffect < Sprite

  # _XvCg
  class Stick < Sprite
    attr_accessor :bx, :by, :dist, :ang_spd, :dist_spd

    def initialize(x, y, img, ang, dist, z)
      self.bx = x
      self.by = y
      self.image = img
      self.dist = dist
      set_xy
      super(self.x, self.y, self.image)
      self.center_x = 0
      self.center_y = self.image.height / 2
      self.angle = ang
      self.alpha = 255
      self.scale_x = rand(20) / 100.0 + 0.1
      self.scale_y = 0.5
      self.ang_spd = (rand(400) - 200) / 100.0
      self.ang_spd = 0.5 if self.ang_spd == 0
      self.dist_spd = rand(250) / 100.0 + 2
    end

    def update
      self.dist += self.dist_spd
      self.angle += self.ang_spd
      self.scale_x += 0.05
      self.scale_y -= 0.01
      self.alpha -= 5
      if self.alpha <= 0
        self.alpha = 0
        self.vanish
      end
      set_xy
    end

    def set_xy
      rad = self.angle * Math::PI / 180.0
      self.x = self.bx + self.dist * Math.cos(rad)
      self.y = self.by + self.dist * Math.sin(rad) - self.image.height / 2
    end
  end

  attr_accessor :px, :py, :stick_img, :ring_img, :sprs

  def initialize(x, y, img1, img2, z=20)
    self.px = x
    self.py = y
    self.image = img1 # O摜
    set_xy
    super(self.x, self.y, self.image)
    self.z = z
    self.scale_x = self.scale_y = 0.25
    self.alpha = 255
    self.blend = :add

    # _XvCg𔭐
    self.sprs = []
    30.times do |i|
      self.sprs.push(Stick.new(x, y, img2, rand(360), 16, z))
    end
  end

  def update
    Sprite.update(self.sprs)

    self.scale_x += (1.5 - self.scale_x) * 0.1
    self.scale_y = self.scale_x

    self.alpha -= 3
    if self.alpha <= 0
      self.alpha = 0
      self.vanish
    end
  end

  def set_xy
    self.x = self.px - self.image.width / 2
    self.y = self.py - self.image.height / 2
  end

  def draw
    super
    Sprite.draw(self.sprs)
  end
end

if $0 == __FILE__
  # eXg
  img1 = Image.load("res/ring.png")
  img2 = Image.load("res/stick.png")
  sprs = []
  count = 0
  Window.loop do
    break if Input.keyPush?(K_ESCAPE)
    if count % 90 == 0
      x = 320
      y = 240
      sprs.push(DeadEffect.new(x, y, img1, img2))
    end

    Sprite.update(sprs)
    Sprite.clean(sprs)
    Sprite.draw(sprs)
    count += 1
  end
end
