#!ruby -Ks
# -*- mode: ruby; encoding: sjis -*-
# Last updated: <2014/01/25 21:13:52 +0900>

require 'dxruby'
require_relative 'globalwork'
require_relative 'enemyzakoagen'
require_relative 'enemyzakobgen'
require_relative 'enemyzakoc'
require_relative 'enemycannon'
require_relative 'stage1boss'

# GNX
class EnemyBorn
  attr_accessor :idx, :tbls

  def initialize(enemy_tbl)
    self.idx = 0
    self.tbls = enemy_tbl

    # self.tbls.each {|d| p d }
  end

  def update
    bx, by = $g.get_bg_pos
    chk_x = bx + Window.width + 64
    while self.idx < self.tbls.length
      d = self.tbls[self.idx]
      break if d[:x] > chk_x
      name, x, y = d[:name], d[:x], d[:y]
      born_enemy(name, x, y, bx, by)

      # puts "Enemy born #{name} x,y=#{x},#{y} bg x,y=#{bx},#{by}"
      self.idx += 1
    end
  end

  # G𔭐
  #
  # @param [String] name Gޕ
  # @param [int] x Wx
  # @param [int] y Wy
  # @param [int] bg_x BGXN[Wx
  # @param [int] bg_y BGXN[Wy
  #
  def born_enemy(name, x, y, bg_x, bg_y)
    x -= bg_x
    y -= bg_y
    case name
    when "zakoa"
      # GGA
      x = Window.width + 32
      $g.sprs_enemy.push(EnemyZakoAGen.new(x, y))
    when "zakob"
      # GGB
      $g.sprs_enemy.push(EnemyZakoBGen.new)
    when "zakoc"
      # GGC
      x = Window.width + 32
      $g.sprs_enemy.push(EnemyZakoC.new(x, y, $g.enemy_imgs[8]))
    when "cannon_u"
      # C
      $g.sprs_enemy.push(EnemyCannon.new(x, y, $g.cannon_imgs, "up"))
    when "cannon_d"
      $g.sprs_enemy.push(EnemyCannon.new(x, y, $g.cannon_imgs, "down"))
    when "cannon_l"
      $g.sprs_enemy.push(EnemyCannon.new(x, y, $g.cannon_imgs, "left"))
    when "cannon_r"
      $g.sprs_enemy.push(EnemyCannon.new(x, y, $g.cannon_imgs, "right"))
    when "bg_stop"
      # BGXN[~
      $g.stop_bg_scroll
    when "stageboss"
      # Xe[W{XG
      $g.sprs_enemy.push(Stage1Boss.new($g.boss_imgs))
    end
  end
end
