#!ruby -Ks
# -*- mode: ruby; encoding: sjis -*-
# Last updated: <2014/01/23 21:23:13 +0900>

require 'dxruby'
require_relative 'globalwork'
require_relative 'gamemath'

# Ge
class EnemyShot < Sprite
  @@pat = [4, 4, 5, 5, 6, 6]
  attr_accessor :px, :py, :imgs, :dx, :dy, :count

  def initialize(x, y, dx, dy)
    self.px = x
    self.py = y
    self.imgs = $g.enemy_imgs
    self.image = self.imgs[@@pat[0]]
    set_xy
    super(self.x, self.y, self.image)
    self.collision = [12, 12, 19, 19]
    self.collision_enable = true
    self.dx = dx
    self.dy = dy
    self.count = 0
  end

  def update
    self.px += self.dx
    self.py += self.dy
    self.image = self.imgs[@@pat[(self.count) % @@pat.length]]

    bg_hit = $g.bg.check_bg_hit(self.px, self.py)
    iw, ih = self.image.width / 2, self.image.height / 2
    x0, y0 = -iw, -ih
    x1, y1 = Window.width + iw, Window.height + ih
    if bg_hit or !(x0..x1).member?(self.px) or !(y0..y1).member?(self.py)
      self.vanish
    end
    set_xy
    self.count += 1
  end

  def set_xy
    self.x = self.px - self.image.width / 2
    self.y = self.py - self.image.height / 2
  end

  def draw
    super
    draw_atari if $g.dbg_atari_disp
  end

  # vC[ɓɌĂ΂
  def shot(d)
    self.vanish
  end

  # A^͈͂`
  def draw_atari
    if self.collision_enable
      x1 = self.x + self.collision[0]
      y1 = self.y + self.collision[1]
      x2 = self.x + self.collision[2]
      y2 = self.y + self.collision[3]
      c = C_GREEN
      Window.drawLine(x1, y1, x2, y1, c)
      Window.drawLine(x2, y1, x2, y2, c)
      Window.drawLine(x2, y2, x1, y2, c)
      Window.drawLine(x1, y2, x1, y1, c)
    end
  end
end
