#!ruby -Ks
# -*- mode: ruby; encoding: sjis -*-
# Last updated: <2014/01/25 22:20:56 +0900>

require 'dxruby'
require_relative 'explosionborn'
require_relative 'enemyshot'

# sinJ[u`GGNX
class EnemyZakoA < Sprite
  attr_accessor :px, :py, :imgs, :bx, :by, :dx, :dh
  attr_accessor :count, :pat_idx
  attr_accessor :shot_timer, :shot_timer_def

  # @@pat = [9, 10, 11, 12, 13, 14, 15]
  @@pat = [17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31]

  # 
  def initialize(x, y, imgs, pat_num, wait_timer, shot_time=60*2)
    self.bx, self.by = x, y
    self.px, self.py = x, y
    self.imgs = imgs
    self.pat_idx = pat_num % @@pat.length
    set_xy
    super(self.x, self.y, self.image)
    self.dx = -2.2
    self.dh = 48
    self.count = 0
    self.collision = [4, 5, 27, 28]
    self.collision_enable = true
    self.shot_timer_def = shot_time
    self.shot_timer = rand(shot_time) + shot_time
  end

  # WXV
  def update
    self.count += 1
    self.px += self.dx
    self.py = self.by + self.dh * Math.sin(self.count * 3 * Math::PI / 180.0)
    self.pat_idx = ((self.pat_idx + 1) % @@pat.length) if self.count % 2 == 0

    self.shot_timer -= 1
    if self.shot_timer < 0
      # e
      if $g.make_enemyshot_typea(self.px, self.py, 120, 3)
        self.shot_timer = self.shot_timer_def
      end
    end

    set_xy
    self.vanish if self.x < -self.image.width
  end

  # Wݒ
  def set_xy
    self.image = self.imgs[@@pat[self.pat_idx]]
    self.x = self.px - (self.image.width / 2)
    self.y = self.py - (self.image.height / 2)
  end

  # vC[̒eɌĂ΂
  def hit(o)
    $g.add_score(10)
    ExplosionBorn.born_explosion(self.px, self.py, -2)
    self.collision_enable = false
    self.vanish
  end
end
