#!ruby -Ks
# -*- mode: ruby; encoding: sjis -*-
# Last updated: <2014/01/25 22:21:16 +0900>

require 'dxruby'
require_relative 'explosionborn'
require_relative 'gamemath'

# vC[ɌĔłGGNX
class EnemyZakoC < Sprite
  DBG = true

  attr_accessor :px, :py, :imgs, :step, :dx, :dy, :spd, :ang_spd, :dbg

  #
  # 
  #
  # @param [int] x Wx
  # @param [int] y Wy
  # @param [Image] img gpImage
  # @param [float] spd x
  # @param [float] ang_spd vC[֌Ăpx
  #
  def initialize(x, y, img, spd=3, ang_spd=1.5, dbg=false)
    self.px, self.py, self.image = x, y, img
    set_xy
    super(self.x, self.y, self.image)
    self.collision = [8, 8, 23, 23]
    self.collision_enable = true
    self.dx = 0
    self.dy = 0
    self.spd = spd
    self.angle = 180
    self.ang_spd = ang_spd
    self.dbg = dbg
    self.step = 0
  end

  # XV
  def update
    # vC[ɂ߂px擾

    if self.dbg
      # mFpB}EXWǔ
      plx = Input.mousePosX
      ply = Input.mousePosY
    else
      plx, ply = $g.get_player_pos
    end

    # vC[ɌĊpxݒBOςgĉE߂
    self.angle = GameMath.get_chase_angle(self.angle, self.ang_spd, \
                                          plx, ply, self.px, self.py)

    # xݒ
    rad = GameMath.deg2rad(self.angle)
    self.dx = self.spd * Math.cos(rad)
    self.dy = self.spd * Math.sin(rad)

    # xZ
    self.px += self.dx
    self.py += self.dy
    set_xy

    # ʍ[𒴂
    if self.px < -self.image.width
      self.vanish
    end
  end

  # `ʒuݒ
  def set_xy
    self.x = self.px - self.image.width / 2
    self.y = self.py - self.image.height / 2
  end

  # vC[̒eɌĂ΂
  def hit(o)
    $g.add_score(10)
    ExplosionBorn.born_explosion(self.px, self.py, -2)
    self.collision_enable = false
    self.vanish
  end
end

if __FILE__ == $0
  # eXg
  imgs = Image.loadTiles("res/enemy_zako1.png", 8, 4)
  sprs = []
  count = 0
  Window.loop do
    break if Input.keyPush?(K_ESCAPE)

    if count % 30 == 0
      # 莞ԂƂɔ
      x = Window.width
      y = rand(Window.height - 128) + 64
      sprs.push(EnemyZakoC.new(x, y, imgs[8], 3, 1.5, true))
    end

    Sprite.update(sprs)
    Sprite.clean(sprs)
    Sprite.draw(sprs)
    count += 1
  end
end
