#!ruby -Ks
# -*- mode: ruby; encoding: sjis -*-
# Last updated: <2014/01/27 01:05:34 +0900>

require 'dxruby'
require_relative 'globalwork'
require_relative 'gamemath'

# AjAނ2BOIɔ΂
class ExplosionBorn2 < Sprite

  class Explosion3d < Sprite
    attr_accessor :bx, :by
    attr_accessor :px, :py
    attr_accessor :tx, :ty, :tz
    attr_accessor :dx, :dy, :dz
    attr_accessor :ang_spd
    attr_accessor :sz

    #
    # 
    #
    # @param [float] x OԍWx
    # @param [float] y OԍWy
    # @param [float] z OԍWz
    # @param [float] bx \̃ItZbgWx
    # @param [float] by \̃ItZbgWy
    # @param [Image] img \Ɏg摜
    # @param [float] spd x
    # @param [float] ang_xy xyW̊px
    # @param [float] ang_yz yzW̊px
    # @param [Object] blend @B:add  :sub w\
    #
    def initialize(x, y, z, bx, by, img, spd, ang_xy, ang_yz, blend)
      self.bx = bx
      self.by = by
      self.tx = x
      self.ty = y
      self.tz = z
      self.image = img

      self.sz = 500

      # xݒ
      dx, dy = GameMath.get_vec(ang_xy, spd)
      self.dx, self.dy = dx, dy
      dy, dz = GameMath.get_vec(ang_yz, spd)
      self.dz = dz

      set_xy
      super(self.x, self.y, self.image)

      w = 15
      self.ang_spd = rand(w) - (w / 2)
      self.ang_spd = 2 if self.ang_spd == 0
      self.angle = rand(360)
      self.alpha = 255
      self.blend = blend
      self.z = 20
    end

    def update
      self.tx += self.dx
      self.ty += self.dy
      self.tz += self.dz
      set_xy

      self.angle += self.ang_spd

      # d = 0.985
      d = 0.995
      self.dx *= d
      self.dy *= d
      self.dz *= d

      self.alpha -= 1
      if self.alpha <= 0
        self.alpha = 0
        self.vanish
      end

      if self.tz <= self.sz or \
        self.x < -128 or self.y < -128 or \
        self.x > Window.width or self.y > Window.height
        self.vanish
      end
    end

    def set_xy
      x = self.sz * tx / tz
      y = self.sz * ty / tz
      scale = self.sz * self.image.height / tz
      scale *= 0.6
      self.scale_x = scale
      self.scale_y = scale
      self.x = x - self.image.width / 2 + self.bx
      self.y = y - self.image.height / 2 + self.by
    end
  end

  # O`
  class Ring < Sprite
    attr_accessor :px, :py, :scale, :scale_spd

    def initialize(x, y, img, scale_spd)
      self.px = x
      self.py = y
      self.image = img
      self.scale = 0.25
      self.scale_spd = scale_spd
      set_xy(self.px, self.py, self.scale)
      super(self.x, self.y, self.image)
      self.blend = :add
      self.alpha = 255
      self.z = 15
    end

    def update
      self.scale += self.scale_spd
      self.scale_spd *= 0.9

      set_xy(self.px, self.py, self.scale)
      self.alpha -= 2
      if self.alpha <= 0
        self.alpha = 0
        self.vanish
      end
    end

    def set_xy(x, y, scale)
      self.scale_x = scale
      self.scale_y = scale
      self.x = x - self.image.width / 2
      self.y = y - self.image.height / 2
    end
  end

  attr_accessor :bx, :by, :imgs, :ring_img, :count, :count2
  attr_accessor :scale_spd
  attr_accessor :dbg

  # ǂ̉摜ǂ̒x̊ŏo邩
  # @@pat_num = [0, 0, 0, 0, 0, 1, 1, 1, 2, 2, 3, 3]
  @@pat_num = [0, 0, 1, 1, 2, 2, 3, 3, 4, 4, 5, 5]

  def initialize(x, y, imgs, dbg=false)
    super
    self.dbg = dbg
    self.bx = x
    self.by = y
    self.imgs = imgs
    self.ring_img = imgs[-1]
    self.count = 0
    self.count2 = 0
    self.scale_spd = 0.26
  end

  def update
    if self.count % 15 == 0
      # O
      spr = Ring.new(x, y, self.ring_img, self.scale_spd)
      if self.dbg
        # mFp
        $sprs.push(spr)
      else
        $g.sprs_explosion.push(spr)
      end
      self.scale_spd += 0.07
      self.count2 += 1
    end

    if self.count == 0
      # 3DjД
      w = 64
      1000.times do |i|
        x = rand(w) - (w / 2)
        y = rand(w) - (w / 2)
        born_one(x, y)
      end
    end

    self.count += 1
    if self.count2 >= 3
      self.vanish
      unless self.dbg
        # Xe[WNAS𔭐
        spr = StageClearLogo.new($g.stageclear_imgs, $g.stage_num, 120)
        $g.sprs.push(spr)
      end
    end
  end

  # p^[
  def born_one(ofs_x, ofs_y)
    spd = rand(50) + 90
    # spd = rand(200)

    w = rand(1000)
    ang_xy = rand(360)
    ang_yz = rand(360)
    rad_xy = GameMath.deg2rad(ang_xy)
    rad_yz = GameMath.deg2rad(ang_yz)
    tx = w * Math.cos(rad_xy)
    ty = w * Math.sin(rad_xy)
    tz = w * Math.cos(rad_yz) * 0.25
    tz += 4000

    blend = (rand(100) <= 50)? :add : :sub

    bx = self.bx + ofs_x
    by = self.by + ofs_y
    spr = Explosion3d.new(tx, ty, tz,
                          bx, by,
                          self.imgs[@@pat_num[rand(@@pat_num.length)]],
                          spd, ang_xy, ang_yz, blend)
    if self.dbg
      # mFp
      $sprs.push(spr)
    else
      # {ԗp
      $g.sprs_explosion.push(spr)
    end
  end

  def draw
  end

  # g摜[h
  def self.load_images
    imgs = Image.loadTiles("res/explosion3.png", 6, 1)
    imgs.push(Image.load("res/ring2.png"))
    return imgs
  end
end

if $0 == __FILE__
  # mF

  imgs = ExplosionBorn2.load_images
  font = Font.new(16)
  $sprs = []

  Window.loop do
    break if Input.keyPush?(K_ESCAPE)

    x, y = Input.mousePosX, Input.mousePosY
    # x, y = 320, 240
    if Input.keyPush?(K_Z)
      spr = ExplosionBorn2.new(x, y, imgs, true)
      $sprs.push(spr)
    end

    Sprite.update($sprs)
    Sprite.clean($sprs)
    Sprite.draw($sprs)

    s = '' * $sprs.length
    Window.drawFont(0, 0, "Push Z key", font)
    Window.drawFont(0, 20, s, font)
  end

end
