#!ruby -Ks
# -*- mode: ruby; encoding: sjis -*-
# Last updated: <2014/01/18 04:53:55 +0900>

require 'dxruby'

# Aj
class ExplosionOne < Sprite
  attr_accessor :px, :py, :imgs, :pat, :anime_pat, :wait_timer
  
  def initialize(x, y, imgs, pat_list, opts={})
    self.px = x
    self.py = y
    self.imgs = imgs
    self.pat = pat_list
    self.anime_pat = 0
    self.image = self.imgs[self.pat[self.anime_pat]]
    set_xy
    super(self.x, self.y, self.image)
    self.angle = rand(360)
    self.z = opts[:z] if opts.has_key?(:z)
    self.blend = opts[:blend] if opts.has_key?(:blend)
    self.alpha = opts[:alpha] if opts.has_key?(:alpha)
    self.scale_x = 1.0
    self.scale_y = 1.0
    self.wait_timer = (opts.has_key?(:wait))? opts[:wait] : 0
    self.visible = false
  end

  def update
    if self.wait_timer <= 0
      self.visible = true
      if self.anime_pat >= self.pat.length
        self.vanish
      else
        self.image = self.imgs[self.pat[self.anime_pat]]
        self.anime_pat += 1
        self.scale_x += 0.02
        self.scale_y += 0.02
      end
    else
      self.wait_timer -= 1
      self.visible = (self.wait_timer <= 0)? true : false
    end
    set_xy
  end

  def set_xy
    self.x = self.px - self.image.width / 2
    self.y = self.py - self.image.height / 2
  end
end
