#!ruby -Ks
# -*- mode: ruby; encoding: sjis -*-
# Last updated: <2014/01/26 22:38:28 +0900>

require 'dxruby'
require 'singleton'

require_relative 'globalwork'
require_relative 'bgdisp'
require_relative 'player'
require_relative 'playershot'
require_relative 'playermissile'
require_relative 'enemyzakoa'
require_relative 'enemyzakob'
require_relative 'enemyzakoc'
require_relative 'enemyborn'
require_relative 'explosionone'
require_relative 'explosionflash'
require_relative 'explosionborn'

# Q[C
class GameMain
  include Singleton

  STEP_GAMEINIT = 0
  STEP_STAGEINIT = 1
  STEP_STAGESTART = 2
  STEP_GAMEMAIN = 3

  @@font = Font.new(12)
  @@startlogo = Image.load("res/start.png")
  @@bg = nil

  attr_accessor :count

  def initialize
    @count = 0
  end

  # XV
  def update
    case $g.step_s
    when STEP_GAMEINIT
      # Q[Ŝ̏
      $g.score = 0
      $g.rest = 3
      $g.stage_num = 0
      $g.gameover_step = 0
      $g.step_s = STEP_STAGEINIT

    when STEP_STAGEINIT
      # Xe[W̏
      srand(0)

      $g.sprs = []
      $g.sprs_player = []
      $g.sprs_playershot = []
      $g.sprs_enemy = []
      $g.sprs_enemyshot = []
      $g.sprs_explosion = []

      $g.sprs_player.push(Player.new(0, 240)) # @

      # BG
      $g.bg = BgDisp.new($g.stage_num, 0, 32, 2, 0, -255)
      # $g.bg = BgDisp.new($g.stage_num, 7500, 32, 2, 0, -255)
      # $g.bg = BgDisp.new($g.stage_num, 4500, 32, 2, 0, -255)

      @@bg = $g.bg

      # Ge[u擾
      $g.enemy_tbl = @@bg.get_enemy_table(@@bg.bg_x)

      # GGobjo^
      $g.sprs.push(EnemyBorn.new($g.enemy_tbl))

      $g.player_dead = 0

      @count = 0
      $g.step_s = STEP_STAGESTART

    when STEP_STAGESTART
      # "START" \
      @count += 1
      if @count >= (0x10 * 6 - 1)
        @count = 0
        $g.framecount = 0
        $g.step_s = STEP_GAMEMAIN
      else
        # uSTARTv`
        x = (Window.width - @@startlogo.width) / 2
        y = (Window.height - @@startlogo.height) / 2
        Window.draw(x, y, @@startlogo) if @count & 0x10 == 0
      end

    when STEP_GAMEMAIN
      # Q[C

      # XvCgWXV
      Sprite.update($g.sprs)
      Sprite.update($g.sprs_player)
      Sprite.update($g.sprs_playershot)
      Sprite.update($g.sprs_enemy)
      Sprite.update($g.sprs_enemyshot)
      Sprite.update($g.sprs_explosion)

      # vC[̒eGG̃A^`FbN
      Sprite.check($g.sprs_playershot, $g.sprs_enemy)

      # GvC[AGevC[̃A^`FbN
      Sprite.check($g.sprs_enemy, $g.sprs_player)
      Sprite.check($g.sprs_enemyshot, $g.sprs_player)

      # svɂȂSpriteo^
      Sprite.clean($g.sprs)
      Sprite.clean($g.sprs_playershot)
      Sprite.clean($g.sprs_enemy)
      Sprite.clean($g.sprs_enemyshot)
      Sprite.clean($g.sprs_explosion)

      @@bg.update

      if $g.gameover_step > 0
        # Q[I[o[ɂȂ
        $g.gameover_step = 0
        $g.step = Scene::TITLE
        $g.step_s = 0
      elsif $g.player_dead > 0
        # vC[1@ꂽ
        # OfBEXۂAꂽXe[WŏA^Cv̏ꍇ͂ʂ
        $g.step_s = STEP_STAGEINIT
      else
        # ʏ̕`揈

        # BG`
        @@bg.draw

        # XvCg`
        Sprite.draw($g.sprs_explosion)
        Sprite.draw($g.sprs_enemy)
        Sprite.draw($g.sprs)
        Sprite.draw($g.sprs_player)
        Sprite.draw($g.sprs_playershot)
        Sprite.draw($g.sprs_enemyshot)

        # XvCg̑`
        h = 16
        l = $g.get_sprs_length
        s = (l > 40)? "#{l}" : ('' * l)
        ld = Window.getLoad.to_i
        fpsv = Window.real_fps
        Window.drawFont(0, h * 0, "REST #{$g.rest} SCORE #{$g.score}", @@font)
        Window.drawFont(0, h * 1, "FPS:#{fpsv} CPU:#{ld}% Sprs:#{s}", @@font)
        bgx, bgy = @@bg.get_bg_pos
        Window.drawFont(0, h * 2, "BG #{bgx}, #{bgy}", @@font)

      end
    end
  end

end
