#!ruby -Ks
# -*- mode: ruby; encoding: sjis -*-
# Last updated: <2014/01/27 01:05:57 +0900>

require 'dxruby'
require 'singleton'
require_relative 'gamemath'
require_relative 'explosionborn2'
require_relative 'stageclearlogo'
require_relative 'shotdead'

# O[oϐ܂Ƃ߂NX
class GlobalWork
  include Singleton

  attr_accessor :step
  attr_accessor :step_s
  attr_accessor :rest
  attr_accessor :score
  attr_accessor :framecount
  attr_accessor :flash_step
  attr_accessor :gameover_step
  attr_accessor :player_dead
  attr_accessor :dbg_atari_disp
  attr_accessor :stage_num

  attr_accessor :sprs
  attr_accessor :sprs_player
  attr_accessor :sprs_playershot
  attr_accessor :sprs_enemy
  attr_accessor :sprs_enemyshot
  attr_accessor :sprs_explosion

  attr_accessor :enemy_imgs
  attr_accessor :shot_imgs
  attr_accessor :explo_imgs
  attr_accessor :explo2_imgs
  attr_accessor :flash_img
  attr_accessor :stick_img
  attr_accessor :ring_img
  attr_accessor :cannon_imgs
  attr_accessor :boss_imgs
  attr_accessor :stageclear_imgs
  attr_accessor :shotdead_imgs

  attr_accessor :bg
  attr_accessor :enemy_tbl

  def initialize
    @dbg_atari_disp = false # A^̕\

    @step = 0
    @step_s = 0
    @rest = 0
    @score = 0
    @framecount = 0
    @flash_step = 0
    @gameover_step = 0
    @player_dead = 0
    @stage_num = 0

    # 摜ǂݍ
    @enemy_imgs = Image.loadTiles("res/enemy_zako1.png", 8, 4)
    @shot_imgs = Image.loadTiles("res/shot.png", 4, 2)
    @explo_imgs = Image.loadTiles("res/explosion1.png", 4, 6)
    @flash_img = Image.load("res/flash.png")
    @stick_img = Image.load("res/stick.png")
    @ring_img = Image.load("res/ring.png")
    @cannon_imgs = Image.loadTiles("res/cannon.png", 3, 1)

    @boss_imgs = Stage1Boss.load_images
    @explo2_imgs = ExplosionBorn2.load_images
    @stageclear_imgs = StageClearLogo.load_images
    @shotdead_imgs = ShotDead.load_images

    @sprs = []
    @sprs_player = []
    @sprs_enemy = []
    @sprs_enemyshot = []
    @sprs_playershot = []
    @sprs_explosion = []

    @bg = nil
    @enemy_tbl = []
  end

  # t[JE^CNg
  def inc_framecount
    @framecount += 1
  end

  # vC[̍WԂ
  def get_player_pos
    px, py = @sprs_player[0].get_player_pos
    return px, py
  end

  # vC[ւ̊pxԂ
  #
  # @param [int] bx W x
  # @param [int] by W y
  # @return [float] vC[ւ̊pxBPʂ̓WA
  #
  def get_dir_player(bx, by)
    px, py = get_player_pos
    return GameMath.get_dir_rad(px, py, bx, by)
  end

  # vC[_Ēe
  def make_enemyshot_typea(bx, by, dist, spd)
    px, py = get_player_pos
    unless GameMath.check_dist(px, py, bx, by, dist)
      rad = GameMath.get_dir_rad(px, py, bx, by)
      dx, dy = GameMath.get_vec_rad(rad, spd)
      @sprs_enemyshot.push(EnemyShot.new(bx, by, dx, dy))
      return true
    end
    return false
  end

  # Ge
  def make_enemyshot(bx, by, dist, ang, spd)
    px, py = get_player_pos
    unless GameMath.check_dist(px, py, bx, by, dist)
      dx, dy = GameMath.get_vec(ang, spd)
      @sprs_enemyshot.push(EnemyShot.new(bx, by, dx, dy))
      return true
    end
    return false
  end

  # XRAZ
  def add_score(v)
    @score += v
  end

  # c@炷
  def dec_rest
    @rest -= 1
    set_flash
  end

  #
  # ʃtbVJn
  #
  # @param [int] fade_spd tF[hAEgxB1-255͈̔́Bȗ̓tF[hAEg
  #
  def set_flash(fade_spd=0)
    @sprs.push(ScreenFlash.new(fade_spd))
  end

  # XvCg擾
  def get_sprs_length
    sprs_length = @sprs.length
    sprs_length += @sprs_playershot.length
    sprs_length += @sprs_enemy.length
    sprs_length += @sprs_enemyshot.length
    sprs_length += @sprs_player.length
    sprs_length += @sprs_explosion.length
    return sprs_length
  end

  # Q[I[o[tO𗧂Ă
  def set_gameover
    @gameover_step = 1
  end

  # vC[1@tO𗧂Ă
  def dead_player
    @player_dead = 1
  end

  # BGWԂ
  def get_bg_pos
    return @bg.get_bg_pos
  end

  # BG̃XN[~߂
  def stop_bg_scroll
    @bg.stop_bg_scroll
  end

  # Geׂď
  def clean_all_enemy_shot
    @sprs_enemyshot.each do |spr|
      spr.vanish
    end
  end
end
