#!ruby -Ks
# -*- mode: ruby; encoding: sjis -*-
# Last updated: <2014/01/25 22:02:26 +0900>

require 'dxruby'
require_relative 'globalwork'
require_relative 'screenflash'
require_relative 'gameoverdisp'
require_relative 'deadeffect'

# vC[@NX
class Player < Sprite

  STEP_INIT = 0
  STEP_MOVE = 1
  STEP_REBORNMOVE = 2
  STEP_DEAD = 3
  STEP_NOJOB = 4

  attr_accessor :px, :py, :imgs
  attr_accessor :shot_timer, :pat_index, :count, :step, :spd
  attr_accessor :born_timer

  @@pat = [2, 1, 0, 3, 4]
  @@pat_center = 2

  # 
  def initialize(x, y)
    self.imgs = Image.loadTiles("res/player_plane.png", 4, 2)
    self.image = self.imgs[0]
    self.px = x
    self.py = y
    set_xy
    super(self.x, self.y, self.image)
    self.step = STEP_INIT
  end

  # Ĕ̃[N
  def init_reborn
    self.px = 0
    self.py = 240
    self.pat_index = @@pat_center
    self.shot_timer = 0
    self.count = 0
    self.born_timer = 3 * 60
    self.step = STEP_REBORNMOVE
  end

  # XV
  def update
    if self.step == STEP_INIT
      # [N
      self.px = 160
      self.py = 240
      self.pat_index = @@pat_center
      self.collision = [50, 29]
      self.spd = 4
      self.shot_timer = 0
      self.count = 0
      self.born_timer = 0
      self.collision_enable = true
      self.step = STEP_MOVE
    end

    case self.step
    when STEP_MOVE
      # ʏ폈

      # ㉺EL[̓͂ňړ
      # ΂ߕɓۂɈړʂȂȂ悤ɁA
      # pxړʂ߂Ă_ɒ
      ang = nil
      ang = ((Input.x > 0)? 0 : 180) if Input.x != 0
      if Input.y != 0
        if ang == nil
          ang = (Input.y > 0)? 90 : 270
        else
          ang += (45 * ((ang == 0)? 1 : -1)) * Input.y
        end
      end
      if ang != nil
        self.px += self.spd * Math.cos(ang * Math::PI / 180.0)
        self.py += self.spd * Math.sin(ang * Math::PI / 180.0)
      end

      # ʊOɏoȂ悤ɕ␳
      iw = 8
      ih = 8
      xmin, ymin = iw, ih
      xmax, ymax = Window.width - iw, Window.height - ih
      self.px = xmin if self.px < xmin
      self.px = xmax if self.px > xmax
      self.py = ymin if self.py < ymin
      self.py = ymax if self.py > ymax

      # ㉺L[͂ŕ\p^[ύX
      if Input.padDown?(P_UP)
        self.pat_index -= 1 if self.count % 6 == 0
        self.pat_index = 0 if self.pat_index < 0
      elsif Input.padDown?(P_DOWN)
        self.pat_index += 1 if self.count % 6 == 0
        self.pat_index = @@pat.length - 1 if self.pat_index >= @@pat.length
      elsif self.pat_index != @@pat_center
        # ㉺L[͂ĂȂꍇ̓j[g̃p^[Ɉڍs
        if self.count % 12 == 0
          self.pat_index += (self.pat_index < @@pat_center)? 1 : -1
        end
      end

      # e
      self.shot_timer += 1
      if self.shot_timer % 6 == 0
        $g.sprs_playershot.push(PlayerShot.new(self.px + 16, self.py))
      end
      if self.shot_timer % 40 == 0
        $g.sprs_playershot.push(PlayerMissile.new(self.px, self.py))
      end

      pat_num = @@pat[self.pat_index]
      self.image = self.imgs[pat_num]
      set_xy

      # BGA^ƃA^
      tx = self.x + self.collision[0]
      ty = self.y + self.collision[1]
      if $g.bg.check_bg_hit(tx, ty)
        # n`Ɠ
        set_hit
      end

    when STEP_REBORNMOVE
      # 
      self.px += self.spd
      self.step = STEP_MOVE if self.px >= 160
      pat_num = @@pat[self.pat_index]
      self.image = self.imgs[pat_num]
      set_xy

    when STEP_DEAD
      # S
      self.count += 1
      if self.count > 240
        self.count = 0
        if $g.rest <= 0
          # c@Ȃ̂ŃQ[I[o[
          $g.sprs.push(GameOverDisp.new)
          self.step = STEP_NOJOB
        else
          # c@͂܂
          if true
            # ̏ōĔ^Cv̏ꍇ̏
            init_reborn
          else
            # ꂽXe[Wŏ^Cv̏ꍇ̏
            $g.dead_player
          end
        end
      end

    when STEP_NOJOB
      # Ȃ
    end

    self.count += 1

    if self.born_timer > 0
      # Ĕ
      self.collision_enable = false # A^𖳂
      self.born_timer -= 1
      if self.born_timer <= 0
        # ĔԂI
        self.born_timer = 0
        self.collision_enable = true # A^L
      end
    end
  end

  # x,yWZbg
  # DXRubyJłȂASprite#offset_sync gďył
  def set_xy
    self.x = self.px - self.image.width / 2
    self.y = self.py - self.image.height / 2
  end

  # `揈
  def draw
    return if self.step >= STEP_DEAD
    return if self.born_timer & 0x02 != 0

    # `
    super

    draw_atari if $g.dbg_atari_disp
  end

  # vC[AGGeɓɌĂ΂
  def hit(o)
    set_hit
  end

  # vC[AGAGeAn`ɓ̏
  def set_hit
    return if self.born_timer > 0
    return if self.step != STEP_MOVE

    # vC[GtFNgo^
    $g.sprs.push(DeadEffect.new(self.px, self.py, $g.ring_img, $g.stick_img))

    self.collision_enable = false
    self.step = STEP_DEAD
    self.count = 0

    # @炷BʃtbVĂ΂Ă
    $g.dec_rest
  end

  # vC[̃A^WԂ
  def get_player_pos
    x = self.x + self.collision[0]
    y = self.y + self.collision[1]
    return x, y
  end

  # vC[̃A^W`
  def draw_atari
    if self.collision_enable
      x, y = get_player_pos
      Window.drawLine(x, y - 8, x, y + 8, C_RED)
      Window.drawLine(x - 8, y, x + 8, y, C_RED)
    end
  end
end
