#!ruby -Ks
# -*- mode: ruby; encoding: sjis -*-
# Last updated: <2014/01/26 22:34:38 +0900>

require 'dxruby'

# vC[̃~TCNX
class PlayerMissile < Sprite
  attr_accessor :px, :py, :imgs, :step, :count, :dx, :dy, :ax
  @@pat_stop = [4]
  @@pat_move = [1, 2, 3, 2]

  def initialize(x, y)
    self.imgs = $g.shot_imgs
    self.image = self.imgs[@@pat_stop[0]]
    self.px = x
    self.py = y
    set_xy
    super(self.x, self.y, self.image)
    self.step = 0
    self.count = 0
    self.dx = -1.5
    self.dy = 2.0
    self.ax = 0.2
    self.collision = [0, 8, 31, 23]
    self.collision_enable = true
  end

  def update
    case self.step
    when 0
      # 
      self.step = 1 if self.count > 30
    when 1
      # 
      self.dx += self.ax
      self.dy *= 0.95
      self.image = self.imgs[@@pat_move[self.count % @@pat_move.length]]
    end
    self.px += self.dx
    self.py += self.dy
    set_xy

    if $g.bg.check_bg_hit(self.px, self.py)
      # nʂɓ
      spr = ShotDead.new(self.px, self.py, $g.shotdead_imgs)
      $g.sprs_explosion.push(spr)
      self.vanish
    elsif self.x > Window.width
      # ʊOɏ
      self.vanish
    end
    self.count += 1
  end

  def set_xy
    self.x = self.px - self.image.width / 2
    self.y = self.py - self.image.height / 2
  end

  # GɓɌĂ΂
  def shot(d)
    self.vanish
  end
end
