#!ruby -Ks
# -*- mode: ruby; encoding: sjis -*-
# Last updated: <2014/01/26 21:46:57 +0900>

require 'dxruby'
require_relative 'globalwork'

# vC[̒eNX
class PlayerShot < Sprite
  attr_accessor :px, :py, :imgs, :spd

  def initialize(x, y)
    self.px = x
    self.py = y
    self.imgs = $g.shot_imgs
    self.image = self.imgs[0]
    set_xy
    super(self.x, self.y, self.image)
    self.spd = 32
    self.collision = [0, 8, 31, 23]
    self.collision_enable = true
  end

  def set_xy
    self.x = self.px - self.image.width / 2
    self.y = self.py - self.image.height / 2
  end

  def update
    self.px += self.spd
    set_xy
    self.x = self.px - self.image.width / 2
    self.y = self.py - self.image.height / 2

    bg_hit = $g.bg.check_bg_hit(self.px, self.py)
    iw, ih = self.image.width / 2, self.image.height / 2
    xmin, ymin = -iw, -ih
    xmax, ymax = Window.width + iw, Window.height + ih
    if bg_hit
      # nʂɓ
      nx, ny, code = $g.bg.get_hosei(self.px, self.py, BgAtari::ADJUST_LEFT)
      spr = ShotDead.new(nx, ny, $g.shotdead_imgs)
      $g.sprs_explosion.push(spr)
      self.vanish
    elsif !(xmin..xmax).member?(self.px) or !(ymin..ymax).member?(self.py)
      # ʊOɏ
      self.vanish
    end
  end

  # GɓɌĂ΂
  def shot(d)
    self.vanish
  end
end
