#!ruby -Ks
# -*- mode: ruby; encoding: sjis -*-
# Last updated: <2014/01/25 22:46:53 +0900>

require 'dxruby'

# ʃtbV
class ScreenFlash < Sprite
  @@whiteimg = nil
  @@blackimg = nil
  @@pat = [0, 0, 0, 1, 1, 1]

  attr_accessor :step, :fade_spd, :alpha

  #
  # 
  #
  # @param [int] fade_spd tF[hAEgxB1-255͈̔́BȗƃtF[hAEg
  #
  def initialize(fade_spd=0)
    unless @@whiteimg
      @@whiteimg = Image.new(640, 480, [255, 255, 255, 255])
      @@blackimg = Image.new(640, 480, [255, 0, 0, 0])
    end
    self.step = 0
    self.fade_spd = fade_spd
    self.alpha = 255
    super(0, 0, @@blackimg)
  end

  # XV
  def update
    self.step += 1
    return if self.step < @@pat.length

    # tbVׂAjp^[͏IĂ
    if self.fade_spd == 0
      # tF[hAEg
      self.vanish
    else
      # tF[hAEgL
      self.alpha -= self.fade_spd
      if self.alpha <= 0
        self.alpha = 0
        self.vanish
      end
    end
  end

  # `揈
  def draw
    if self.step < @@pat.length
      if @@pat[self.step] == 0
        Window.drawAlpha(0, 0, @@blackimg, 224, 10)
      else
        Window.drawEx(0, 0, @@whiteimg, :alpha=>255,
                      :blend=>:add, :z=>10)
      end
    else
      if self.fade_spd != 0
        Window.drawEx(0, 0, @@whiteimg, :alpha=>self.alpha,
                      :blend=>:add, :z=>10)
      end
    end
  end
end

if __FILE__ == $0
  # eXg
  sprs = []
  count = 0
  Window.bgcolor = C_BLUE
  # Window.fps = 2
  font = Font.new(16)

  Window.loop do
    break if Input.keyPush?(K_ESCAPE)
    sprs.push(ScreenFlash.new()) if Input.keyPush?(K_Z)

    Sprite.update(sprs)
    Sprite.clean(sprs)
    Sprite.draw(sprs)

    Window.drawFont(0, 0, "Push Z key : #{count}", font)
    count += 1
  end
end
