#!ruby -Ks
# -*- mode: ruby; encoding: sjis -*-
# Last updated: <2014/01/26 22:31:45 +0900>

require 'dxruby'

# vC[VbgŎGtFNg
class ShotDead < Sprite
  # @@pat = [0, 1, 2, 3]
  @@pat = [
    0, 1, 2, 3, 4, 5, 6, 7,
    8, 9, 10, 11, 12, 13, 14, 15
  ]

  def initialize(x, y, imgs, dx=-2, dy=0)
    @imgs = imgs
    @px = x
    @py = y
    @dx = dx
    @dy = dy
    self.image = @imgs[0]
    set_xy(@px, @py)
    super(self.x, self.y, self.image)
    @cnt = 0
    @cnt2 = 0
    self.blend = :add
    self.angle = rand(180)
    # self.scale_x = 1.0
    # self.scale_y = 1.0
  end

  def update
    self.image = @imgs[@cnt]
    @cnt += 1
    @cnt2 += 1
    set_xy(@px, @py)
    @px += @dx
    @py += @dy
    # self.scale_x += 0.01
    # self.scale_y += 0.01
    self.vanish if @cnt >= @@pat.length
  end

  def set_xy(x, y)
    self.x = x - self.image.width / 2
    self.y = y - self.image.height / 2
  end

  def self.load_images
    # return Image.loadTiles("res/effect0.png", 4, 1)
    # return Image.loadTiles("res/effect1.png", 8, 2)
    return Image.loadTiles("res/effect2.png", 8, 2)
  end
end

if $0 == __FILE__
  # mF
  imgs = ShotDead.load_images
  $sprs = []
  Window.loop do
    break if Input.keyPush?(K_ESCAPE)

    if Input.mousePush?(M_LBUTTON)
      x = Input.mousePosX
      y = Input.mousePosY - 64
      spr = ShotDead.new(x, y, imgs)
      $sprs.push(spr)
    end

    Sprite.update($sprs)
    Sprite.clean($sprs)
    Sprite.draw($sprs)
  end

end
