#!ruby -Ks
# -*- mode: ruby; encoding: sjis -*-
# Last updated: <2014/01/26 07:42:35 +0900>

require 'dxruby'

# Xe[WNAS
class StageClearLogo < Sprite

  class LogoOne < Sprite
    attr_accessor :px, :py, :tgtx, :tgty, :dx, :dy, :step, :timer, :scale

    #
    # S摜
    #
    # @param [float] x Wx
    # @param [float] y Wy
    # @param [float] tgtx ڕWWx
    # @param [float] tgty ڕWWy
    # @param [Image] img \摜
    # @param [float] dx ʊOɏĂۂ̑xx
    # @param [float] dy ʊOɏĂۂ̑xy
    # @param [int] z `[xB}CiXlȂ牜BvXlȂO
    #
    def initialize(x, y, tgtx, tgty, img, dx, dy, z)
      self.px = x
      self.py = y
      self.tgtx = tgtx
      self.tgty = tgty
      self.dx = dx
      self.dy = dy
      self.image = img
      self.step = 0
      self.timer = 95
      self.scale = 8.0
      self.alpha = 255
      self.z = z
    end

    def update
      case self.step
      when 0
        # ڕWW܂ňړ
        d = 0.2
        self.px += (self.tgtx - self.px) * d
        self.py += (self.tgty - self.py) * d
        self.scale += (1.0 - self.scale) * 0.2
        if (self.tgtx - self.px).abs < 1.0 and (self.tgty - self.py).abs < 1.0
          self.px = self.tgtx
          self.py = self.tgty
        end

        self.timer -= 1
        if self.timer <= 0
          self.step += 1
        end

      when 1
        # ʊOɔł
        self.px += self.dx
        self.py += self.dy
        d = 1.15
        self.dx *= d
        self.dy *= d
        self.scale *= 0.98
        self.alpha -= 6
        if self.px < -64 or self.py < -64 or \
          self.px > Window.width + 64 or self.py > Window.height + 64 or \
          self.alpha <= 0
          # ʊOɏoAAt@l0ȉȂ
          self.alpha = 0
          self.vanish
        end
      end

      self.x = self.px - self.image.width / 2
      self.y = self.py - self.image.height / 2
      self.scale_x = self.scale
      self.scale_y = self.scale
    end
  end

  @@blackimg = nil

  attr_accessor :imgs, :timer, :step, :sprs, :stage_num, :dbg

  # Ɖ摜ԍ̑Ή\
  @@dic_lst = {
    "0"=>0, "1"=>1, "2"=>2, "3"=>3, "4"=>4, "5"=>5, "6"=>6, "7"=>7,
    "8"=>8, "9"=>9, "A"=>10, "C"=>11, "E"=>12, "G"=>13, "L"=>14, "R"=>15,
    "S"=>16, "T"=>17, " "=>18
  }

  #
  # Xe[WNAS
  #
  # @param [Array] imgs S摜Q
  # @param [int] stage_num Xe[WԍB0Xe[W1
  # @param [int] wait ܂ł̑҂
  #
  def initialize(imgs, stage_num, wait=0, dbg=false)
    if @@blackimg == nil
      @@blackimg = Image.new(640, 480, [255, 0, 0, 0])
    end
    super(0, 0, @@blackimg)
    self.alpha = 0
    self.z = 10
    self.visible = false

    self.dbg = dbg
    self.stage_num = stage_num
    self.imgs = imgs
    self.timer = wait
    self.step = 0
    self.sprs = []
  end

  def update
    case self.step
    when 0
      # ԑ҂
      self.timer -= 1
      if self.timer <= 0
        # S摜𔭐
        sn = self.stage_num + 1
        born_logo("STAGE #{sn}", 240 - 40, 30)
        born_logo("CLEAR", 240 + 40, 20)
        self.timer = 300
        self.visible = true
        self.step += 1
      end

    when 1
      # tF[hAEg
      self.alpha += 1 if self.alpha < 255
      self.alpha = 255 if self.alpha >= 255
      self.timer -= 1
      if self.timer <= 0
        self.vanish

        # Xe[WI
        $g.set_gameover
        self.step += 1
      end

    when 2
      # Ȃ
    end
  end

  # S摜𔭐
  def born_logo(s, ty, z)
    z += s.length

    w = 50 # 1̕
    slist = s.split('') # zɕϊ

    # S摜񂾕߂
    sw = 0
    slist.each {|c| sw += (c == " ")? (w / 3) : w}

    tx = (Window.width - sw) / 2 + (w / 2)
    dx = 0
    dy = -2
    cx = Window.width / 2
    cy = Window.height / 2
    self.sprs = []
    slist.each do |c|
      rad = Math.atan2(cy - ty, cx - tx)
      d = 800 * 1.5
      x = d * Math.cos(rad) + tx
      y = d * Math.sin(rad) + ty

      rad = rad - (Math::PI / 4)
      d = 4
      dx = d * Math.cos(rad)
      dy = d * Math.sin(rad)

      imgn = @@dic_lst[c]
      spr = LogoOne.new(x, y, tx, ty, self.imgs[imgn], dx, dy, z)
      if self.dbg
        # mFp
        $sprs.push(spr)
      else
        $g.sprs.push(spr)
      end

      if c == " "
        tx += w / 3
      else
        tx += w
      end
      z -= 1
    end

  end

  # gp摜[h
  def self.load_images
    imgs = Image.loadTiles("res/stageclearlogo.png", 19, 1)
    return imgs
  end
end

if $0 == __FILE__
  # mF

  imgs = StageClearLogo.load_images
  $sprs = []

  Window.loop do
    break if Input.keyPush?(K_ESCAPE)

    $sprs.push(StageClearLogo.new(imgs, 1, 10, true)) if Input.keyPush?(K_Z)

    Sprite.update($sprs)
    Sprite.clean($sprs)
    Sprite.draw($sprs)
  end
end
