#!ruby -Ks
# -*- mode: ruby; encoding: sjis -*-
# Last updated: <2014/01/27 07:51:23 +0900>

require 'dxruby'
require_relative 'globalwork'
require_relative 'gamemain'
require_relative 'mbraster'

# ^Cg
class Title
  @@bg = nil
  @@logo = nil
  @@btnlogo = nil
  @@fade = nil

  def initialize
    @@bg = Image.load("res/titlebg.png") if @@bg == nil
    @@logo = Image.load("res/titlelogo.png") if @@logo == nil
    @@btnlogo = Image.load("res/pushbuttontostart.png") if @@btnlogo == nil
    @@fade = Image.new(Window.width, Window.height, C_BLACK) if @@fade == nil

    # ^ubÑ^Cgʂۂp[N
    @mb_logo = MbRaster.new(@@logo)
    @ang = 360
    @lvldef = 0.35
    @lvl = @lvldef
    @spd = 1.0
  end

  # XV
  def update
    case $g.step_s
    when 0, 1
      if $g.step_s == 0
        # 
        @alpha = 0
        @count = 0
        $g.step_s += 1
      end

      if @count < 60 * 4
        @ang -= 2
        @lvl = 0.1 * Math.sin(@ang * Math::PI / 180.0) + 0.3
      else
        @ang %= 360
        @ang -= 2 if @ang > 0
        @ang = 0 if @ang < 0
        @lvl -= (@lvldef / 120) if @lvl > 0
        @lvl = 0 if @lvl < 0
      end

      if Input.padPush?(P_BUTTON0)
        @ang = 0
        @lvl = 0
        $g.step_s += 1
      end
    when 2
      # tF[hAEg
      @alpha += 10
      if @alpha >= 255
        @alpha = 255

        $g.step = Scene::GAMEMAIN # ̃V[ֈڍs
        $g.step_s = 0
      end
    end
    @count += 1

    # wi`
    Window.draw(0, 0, @@bg)

    # S`
    @mb_logo.draw(0, 0, 0, 0, @ang, @lvl, @spd)
    # Window.draw(0, 0, @@logo)

    # uPUSH STARTv`
    x = (Window.width - @@btnlogo.width) / 2
    y = Window.height - @@btnlogo.height - 32
    Window.draw(x, y, @@btnlogo) if @count & 0x20 == 0

    # tF[hAEgp摜`
    Window.drawAlpha(0, 0, @@fade, @alpha) if @alpha > 0
  end
end
